'use strict';



class Command{
    constructor(args) {
        if(!args) {
            throw new Error('参数不能为空')
        }
        if(!Array.isArray(args)) {
            throw new Error('传递的必须是数组')
        }
        if(args.length === 0) {
            throw new Error('数组列表为空')
        }
        this._args = args;
        new Promise((resolve, reject) => {
            const chain = Promise.resolve();
            chain.then(() => this.initArgs()).then(() => {
                this.init();
            }).then(() => {
                this.exec();
            }).catch(err => {
                console.error(err.message)
            })
        })
    }

    init() {
        throw new Error('init必须实现')
    }
    exec() {
        throw new Error('exec必须实现')
    }

    initArgs() {
        this._cmd = this._args[this._args.length - 1];
        this._args = this._args.slice(0, this._args.length - 1);
    }
}

module.exports = Command;
